DECLARE SUB DrawScene ()
'Made by Sane at the 9th of November 2001, for QBCM
'Set amount of vertices and polys
CONST NumOfVertices = 50
CONST NumOfPolys = 10

'Variable initializing
TYPE VertexType
 X AS SINGLE
 Y AS SINGLE
 Z AS SINGLE
END TYPE

DIM SHARED Vertex(0 TO NumOfVertices) AS VertexType
DIM SHARED Poly(0 TO NumOfPolys, 2) AS INTEGER

'Creating a random scene
FOR i = 0 TO NumOfVertices
 Vertex(i).X = INT(RND * 200) - 50
 Vertex(i).Y = INT(RND * 200) - 100
 Vertex(i).Z = INT(RND * 200) - 100
NEXT i

FOR i = 0 TO NumOfPolys
 FOR j = 0 TO 2
  Poly(i, j) = INT(RND * NumOfVertices)
 NEXT j
NEXT i

'Set screen mode
SCREEN 13

FOR i = 0 TO 100
 'A simple animation thing
 FOR j = 0 TO NumOfVertices
  Vertex(j).X = Vertex(j).X - 1
 NEXT j
 'Redraw, wait for retrace and clear the screen
 DrawScene
 WAIT &H3DA, 8
 CLS
NEXT i

SUB DrawScene
 FOR p = 0 TO NumOfPolys
  X1 = Vertex(Poly(p, 0)).X
  X2 = Vertex(Poly(p, 1)).X
  X3 = Vertex(Poly(p, 2)).X
  Y1 = Vertex(Poly(p, 0)).Y
  Y2 = Vertex(Poly(p, 1)).Y
  Y3 = Vertex(Poly(p, 2)).Y
  Z1 = Vertex(Poly(p, 0)).Z
  Z2 = Vertex(Poly(p, 1)).Z
  Z3 = Vertex(Poly(p, 2)).Z
  SX1 = 256 * (X1) / (256 - Z1) + 160
  SX2 = 256 * (X2) / (256 - Z2) + 160
  SX3 = 256 * (X3) / (256 - Z3) + 160
  SY1 = 256 * (Y1) / (256 - Z1) + 100
  SY2 = 256 * (Y2) / (256 - Z2) + 100
  SY3 = 256 * (Y3) / (256 - Z3) + 100
  LINE (SX1, SY1)-(SX2, SY2)
  LINE (SX2, SY2)-(SX3, SY3)
  LINE (SX3, SY3)-(SX1, SY1)
 NEXT p
END SUB

